#include <sys/ioctl.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <unistd.h>
#include <linux/videodev.h>

#include "main.h"

#define FORMAT VIDEO_PALETTE_YUV422

struct video_capability vcap;
struct video_channel vc[5];
struct video_picture    vp;
struct video_mbuf vm;
struct video_mmap vmm;

static int NowFrame = 0;
extern struct DATA data;

bool device_open(char *device,int *video, int din)
{
  int i;
  extern struct PIC_SIZE pic;

  /* Video4Linux ǥХΥץ */
  if((*video=open(device, O_RDWR))<0) {
    perror("open");
    return (false);
  }

  /* Video4Linux ǥХͤμ */
  if(ioctl(*video, VIDIOCGCAP, &vcap)<0) {
    perror("ioctl(VIDIOCGCAP)");
    return (false);
  }
  #if 0
  /* ǥХ̾ */
  fprintf(stderr, "vcap.name: \"%s\"\n", vcap.name);
  /* ǥХΥ*/
  fprintf(stderr, "vcap.type=0x%08x", vcap.type);
  if(vcap.type&VID_TYPE_CAPTURE) fprintf(stderr, " CAPTURE");
  if(vcap.type&VID_TYPE_TUNER) fprintf(stderr, " TUNER");
  if(vcap.type&VID_TYPE_TELETEXT) fprintf(stderr, " TELETEXT");
  if(vcap.type&VID_TYPE_OVERLAY) fprintf(stderr, " OVERLAY");
  if(vcap.type&VID_TYPE_CHROMAKEY) fprintf(stderr, " CHROMAKEY");
  if(vcap.type&VID_TYPE_CLIPPING) fprintf(stderr, " CLIPPING");
  if(vcap.type&VID_TYPE_FRAMERAM) fprintf(stderr, " FRAMERAM");
  if(vcap.type&VID_TYPE_SCALES) fprintf(stderr, " SCALES");
  if(vcap.type&VID_TYPE_MONOCHROME) fprintf(stderr, " MONOCHROME");
  if(vcap.type&VID_TYPE_SUBCAPTURE) fprintf(stderr, " SUBCAPTURE");
  fprintf(stderr, "\n");
  /* ϥ */
  fprintf(stderr, "vcap.channels=%d\n", vcap.channels);
  /* ǥǥХ */
  fprintf(stderr, "vcap.audios=%d\n", vcap.audios);
  /* 祭ץ */
  fprintf(stderr, "vcap.maxwidth=%d\n", vcap.maxwidth);
  /* 祭ץ⤵ */
  fprintf(stderr, "vcap.maxheight=%d\n", vcap.maxheight);
  /* Ǿץ */
  fprintf(stderr, "vcap.minwidth=%d\n", vcap.minwidth);
  /* Ǿץ⤵ */
  fprintf(stderr, "vcap.minheight=%d\n", vcap.minheight);
  fprintf(stderr, "\n");
#endif
  
  /* ץ㥵Ĵ */
  if(pic.width > vcap.maxwidth) pic.width = vcap.maxwidth;
  if(pic.width < vcap.minwidth) pic.width = vcap.minwidth;
  if(pic.height > vcap.maxheight) pic.height = vcap.maxheight;
  if(pic.height < vcap.minheight) pic.height = vcap.minheight;
  

  /* ƥͥͼ */
  for(i=0; i<vcap.channels; i++) {
    vc[i].channel=i;
    if(ioctl(*video, VIDIOCGCHAN, &vc[i])<0) {
      perror("ioctl(VIDIOCGCHAN)");
      return (false);
    }
#if 0
    fprintf(stderr, "vc[%d].channel=%d\n", i, vc[i].channel);
    fprintf(stderr, "vc[%d].name=\"%s\"\n", i, vc[i].name);
    fprintf(stderr, "vc[%d].tuners=%d\n", i, vc[i].tuners);
    fprintf(stderr, "vc[%d].flags=0x%08x", i, vc[i].flags);
    if(vc[i].flags&VIDEO_VC_TUNER) fprintf(stderr, " TUNER");
    if(vc[i].flags&VIDEO_VC_AUDIO) fprintf(stderr, " AUDIO");
    fprintf(stderr, "\n");
    fprintf(stderr, "vc[%d].type=0x%08x", i, vc[i].type);
    if(vc[i].type&VIDEO_TYPE_TV) fprintf(stderr, " TV");
    if(vc[i].type&VIDEO_TYPE_CAMERA) fprintf(stderr, " CAMERA");
    fprintf(stderr, "\n");
    fprintf(stderr, "vc[%d].norm=%d\n", i, vc[i].norm);
    fprintf(stderr, "\n");
#endif
  }
  
  /*  ü */
  if(ioctl(*video, VIDIOCSCHAN, &vc[din])<0) {
    perror("ioctl(VIDIOCSCHAN)");
    return (false);
  }

  /* ĴȤ( 0-65535) */
  vp.brightness=100<<8;
  vp.hue=128<<8;
  vp.colour=254<<7;
  vp.contrast=216<<7;
  //vp.depth=24;                  /* color depth */
  vp.palette=FORMAT; /* ѥåȷ */
  if(ioctl(*video, VIDIOCSPICT, &vp)) {
    perror("ioctl(VIDIOCSPICT)");
    return (false);
  }

  /* mmap μ */
  if(ioctl(*video, VIDIOCGMBUF, &vm)<0) {
    perror("ioctl(VIDIOCGMBUF)");
    return (false);
  }
#if 0
  fprintf(stderr, "vm.size=0x%08x\n", vm.size);
  fprintf(stderr, "vm.frames=0x%08x\n", vm.frames);
  for(i=0; i<vm.frames; i++)
    fprintf(stderr, "vm.offsets[%d]=0x%08x\n", i, vm.offsets[i]);
  fprintf(stderr, "\n");
#endif

  /* mmap */
  if((data.map = (unsigned char *)mmap(0, vm.size, PROT_READ|PROT_WRITE, MAP_SHARED, *video, 0))==(unsigned char *)-1) { perror("mmap");
  return (false);
  }
  
  /* frame */
  vmm.width  = pic.width;
  vmm.height = pic.height;
  vmm.format = FORMAT;
  
  /* frame #0 ˥ץ㳫ϻؼ */
  vmm.frame = 0;
  if(ioctl(*video, VIDIOCMCAPTURE, &vmm)<0) {
    perror("ioctl(VIDIOCMCAPTURE)");
    return (false);
  }
  
  /* frame #1 ˥ץ㳫ϻؼ */
  vmm.frame = 1;
  if(ioctl(*video, VIDIOCMCAPTURE, &vmm)<0) {
    perror("ioctl(VIDIOCMCAPTURE:1)");
    return (false);
  }

  return (true);
}


void get_image(int *video)
{
  extern struct PIC_SIZE pic;

  if(NowFrame == 0){
    /* frame #0 ץ㽪λԤ */
    if(ioctl(*video,VIDIOCSYNC,&NowFrame)<0){ perror("ioctl(VIDIOCSYNC)"); }
    memcpy(data.pdata,data.map,sizeof(unsigned char)*(pic.width * pic.width * 2));
    vmm.frame = 0;    
    /* frame #0 ˥ץ㳫ϻؼ */
    if(ioctl(*video,VIDIOCMCAPTURE,&vmm)<0){perror("ioctl(VIDIOCMCAPTURE)");}
    NowFrame = 1;
  }
  else{
    /* frame #1 ץ㽪λԤ */
    if(ioctl(*video,VIDIOCSYNC,&NowFrame)<0){ perror("ioctl(VIDIOCSYNC)"); }
    memcpy(data.pdata,data.map+vm.offsets[1],sizeof(unsigned char) * (pic.width * pic.width * 2));
    vmm.frame = 1;
    /* frame #1 ˥ץ㳫ϻؼ */
    if(ioctl(*video,VIDIOCMCAPTURE,&vmm)<0){perror("ioctl(VIDIOCMCAPTURE)");}
    NowFrame = 0;
  }

}

void device_close(int *video)
{
  close(*video);
}










